diff --git a/src/opencl_pgpdisk_fmt_plug.c b/src/opencl_pgpdisk_fmt_plug.c
index 60142e88d4..a070a99608 100644
--- a/src/opencl_pgpdisk_fmt_plug.c
+++ b/src/opencl_pgpdisk_fmt_plug.c
@@ -253,37 +253,37 @@ static char *get_key(int index)
 static int crypt_all(int *pcount, struct db_salt *salt)
 {
 	const int count = *pcount;
-	size_t *lws = local_work_size ? &local_work_size : NULL;
-
-	global_work_size = GET_MULTIPLE_OR_BIGGER(count, local_work_size);
+	size_t gws = count;
+	size_t *lws = (local_work_size && !(gws % local_work_size)) ?
+		&local_work_size : NULL;
 
 	// Copy data to gpu
 	BENCH_CLERROR(clEnqueueWriteBuffer(queue[gpu_id], mem_in, CL_FALSE, 0,
-		insize, inbuffer, 0, NULL, multi_profilingEvent[0]),
-		"Copy data to gpu");
+		sizeof(pgpdisk_password) * gws, inbuffer, 0, NULL,
+	    multi_profilingEvent[0]), "Copy data to gpu");
 
 	// Run kernel
 	if (cur_salt->algorithm == 3) {
 		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], cast_kernel, 1,
-			NULL, &global_work_size, lws, 0, NULL,
+			NULL, &gws, lws, 0, NULL,
 			multi_profilingEvent[1]),
 			"Run kernel");
 	} else if (cur_salt->algorithm == 4) {
 		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], twofish_kernel, 1,
-			NULL, &global_work_size, lws, 0, NULL,
+			NULL, &gws, lws, 0, NULL,
 			multi_profilingEvent[1]),
 			"Run kernel");
 	} else /* if (cur_salt->algorithm >= 5) */ {
 		BENCH_CLERROR(clEnqueueNDRangeKernel(queue[gpu_id], aes_kernel, 1,
-			NULL, &global_work_size, lws, 0, NULL,
+			NULL, &gws, lws, 0, NULL,
 			multi_profilingEvent[1]),
 			"Run kernel");
 	}
 
 	// Read the result back
 	BENCH_CLERROR(clEnqueueReadBuffer(queue[gpu_id], mem_out, CL_TRUE, 0,
-		outsize, outbuffer, 0, NULL, multi_profilingEvent[2]),
-		"Copy result back");
+		sizeof(pgpdisk_hash) * gws, outbuffer, 0, NULL,
+	    multi_profilingEvent[2]), "Copy result back");
 
 	return count;
 }
